// PgTweaks.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "SearchDlg.h"
#include "PPgTweaks.h"
#include "Scheduler.h"
#include "ClientCredits.h"//Pawcio
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#define	DFLT_MAXCONPERFIVE	20


///////////////////////////////////////////////////////////////////////////////
// CPPgTweaks dialog

IMPLEMENT_DYNAMIC(CPPgTweaks, CPropertyPage)

BEGIN_MESSAGE_MAP(CPPgTweaks, CPropertyPage)
	ON_WM_HSCROLL()	
	ON_WM_DESTROY()
	ON_MESSAGE(WM_TREEOPTSCTRL_NOTIFY, OnTreeOptsCtrlNotify)
END_MESSAGE_MAP()

CPPgTweaks::CPPgTweaks()
	: CPropertyPage(CPPgTweaks::IDD)
	, m_ctrlTreeOptions(theApp.m_iDfltImageListColorFlags)
{
	m_bInitializedTreeOpts = false;
	m_htiMaxCon5Sec = NULL;
	m_htiAutoTakeEd2kLinks = NULL;
	m_htiVerbose = NULL;
	m_htiDebugSourceExchange = NULL;
	m_htiCreditSystem = NULL;
	m_htiSaveLogs = NULL;
	m_htiLog2Disk = NULL;
	m_htiDebug2Disk = NULL;
	m_htiCommit = NULL;
	m_htiCommitNever = NULL;
	m_htiCommitOnShutdown = NULL;
	m_htiCommitAlways = NULL;
	m_htiFilterLANIPs = NULL;
	m_htiExtControls = NULL;
	m_htiServerKeepAliveTimeout = NULL;
	m_AdditionalTweaks = NULL; //Pawcio: Additional Tweaks
	m_ProReleasersTweaks = NULL; //Pawcio: Pro-Releaser
	m_SourceHandlingTweaks = NULL; //Pawcio: Source Handling
	m_htiPawcioCredits = NULL; //Pawcio: Credits
	m_htiRedFiles = NULL;//Pawcio: Red Files
	m_htiWQOF = NULL; //Xman: Waiting Queue Overflow
	m_htiCheckDiskspace = NULL;	// SLUGFILLER: checkDiskspace
	m_htiMinFreeDiskSpace = NULL;
	m_htiYourHostname = NULL;	// itsonlyme: hostnameSource
	m_htiEnableAntiLeecher = NULL; //MORPH - Added by IceCream, activate Anti-leecher
	m_htiEnableAntiCreditHack = NULL; //MORPH - Added by IceCream, activate Anti-CreditHack
	// The Black Hand: Antivirus Check - Pawcio
	otiAV = NULL;
	otiAVFileCheck = NULL;
	otiAVParameter = NULL;
	otiFile = NULL;
	// The Black Hand: Antivirus Check - Pawcio
	// SLUGFILLER: hideOS
	m_htiHideOS = NULL;
	m_htiSelectiveShare = NULL;
	// SLUGFILLER: hideOS
	m_htiInfiniteQueue = NULL;	// SLUGFILLER: infiniteQueue
	m_htiDropHQRS = NULL; //Pawcio: HQRS
	//Sivka: AutoHL
	m_htiEnableAutoHL = NULL;
	m_htiHardLimitTimer = NULL;
	m_htiEnableACC = NULL; //Obelix
	m_htiHighProcess = NULL; //MORPH - Added by IceCream, high process priority
	//Sivka: AutoHL
	m_htiEDT = NULL; //enkeyDev -EDT-
}

CPPgTweaks::~CPPgTweaks()
{
}

void CPPgTweaks::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EXT_OPTS, m_ctrlTreeOptions);
	if (!m_bInitializedTreeOpts)
	{
		int iImgBackup = 8; // default icon
		int iImgLog = 8; // default icon
		int iAddTweaks = 8; //Pawcio: Additional Tweaks
		int iRel = 8; //Pawcio: Pro-Releasers
		int iSources = 8; //Pawcio: Sources Handling
		CImageList* piml = m_ctrlTreeOptions.GetImageList(TVSIL_NORMAL);
		if (piml){
			iImgBackup = piml->Add(CTempIconLoader("SafeFileWrite"));
			iImgLog = piml->Add(CTempIconLoader("Log"));
			iAddTweaks = piml->Add(CTempIconLoader("PREF_TWEAK"));
			iRel = piml->Add(CTempIconLoader("PREF_WEBSERVER"));
			iSources = piml->Add(CTempIconLoader("SOURCESHANDL"));
			}
			
		m_AdditionalTweaks = m_ctrlTreeOptions.InsertGroup(GetResString(IDS_PREFS_ADDTWEAKS), iAddTweaks, TVI_ROOT);
		// The Black Hand: Antivirus Check - Pawcio
		otiAV = m_ctrlTreeOptions.InsertGroup(_T("AntiVirus"), iImgBackup, m_AdditionalTweaks);
		otiAVFileCheck = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_AVCHECK), otiAV, m_iAV);
		otiFile = m_ctrlTreeOptions.InsertItem(GetResString(IDS_AVFILE), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT,otiAV);
		m_ctrlTreeOptions.AddFileEditBox(otiFile,  RUNTIME_CLASS(CTreeOptionsEdit),  RUNTIME_CLASS(CTreeOptionsBrowseButton));
		otiAVParameter = m_ctrlTreeOptions.InsertItem(GetResString(IDS_AVPARAMETER),TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, otiAV);
		m_ctrlTreeOptions.AddEditBox(otiAVParameter, RUNTIME_CLASS(CTreeOptionsEdit));
		// The Black Hand: Antivirus check - Pawcio
		m_ProReleasersTweaks = m_ctrlTreeOptions.InsertGroup(GetResString(IDS_PREFS_ADDTWEAKS), iRel, m_AdditionalTweaks); //Pawcio: Pro-Releaser
		m_SourceHandlingTweaks = m_ctrlTreeOptions.InsertGroup(GetResString(IDS_PREFS_ADDTWEAKS), iSources, m_AdditionalTweaks); //Pawcio: Source Handling
		m_htiMaxCon5Sec = m_ctrlTreeOptions.InsertItem(GetResString(IDS_MAXCON5SECLABEL), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, TVI_ROOT);
		m_ctrlTreeOptions.AddEditBox(m_htiMaxCon5Sec, RUNTIME_CLASS(CNumTreeOptionsEdit));
		m_htiAutoTakeEd2kLinks = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_AUTOTAKEED2KLINKS), TVI_ROOT, m_iAutoTakeEd2kLinks);
		m_htiVerbose = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_VERBOSE), TVI_ROOT, m_iVerbose);
		m_htiDebugSourceExchange = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_DEBUG_SOURCE_EXCHANGE), TVI_ROOT, m_iDebugSourceExchange);
		m_ctrlTreeOptions.SetCheckBoxEnable(m_htiDebugSourceExchange, m_iVerbose);
		m_htiCreditSystem = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_USECREDITSYSTEM), TVI_ROOT, m_iCreditSystem);
		// SLUGFILLER: hideOS
		m_htiHideOS = m_ctrlTreeOptions.InsertItem(GetResString(IDS_HIDEOVERSHARES), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_ProReleasersTweaks);
		m_ctrlTreeOptions.AddEditBox(m_htiHideOS, RUNTIME_CLASS(CNumTreeOptionsEdit));
		m_htiSelectiveShare = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_SELECTIVESHARE), m_ProReleasersTweaks, m_iSelectiveShare);
		// SLUGFILLER: hideOS
		//Pawcio: Limits for PS
		m_htiPSforPF = m_ctrlTreeOptions.InsertItem(GetResString(IDS_PSFORPF), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_ProReleasersTweaks);
		m_ctrlTreeOptions.AddEditBox(m_htiPSforPF, RUNTIME_CLASS(CNumTreeOptionsEdit));
		m_htiPSforCF = m_ctrlTreeOptions.InsertItem(GetResString(IDS_PSFORCF), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_ProReleasersTweaks);
		m_ctrlTreeOptions.AddEditBox(m_htiPSforCF, RUNTIME_CLASS(CNumTreeOptionsEdit));
		m_htiIsAutoPowershareNewDownloadFile = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_POWERSHARE_AUTONEWDOWNLOADFILE), m_ProReleasersTweaks, m_bIsAutoPowershareNewDownloadFile); //MORPH - Added by SiRoB, Avoid misusing of powersharing
		//Xman: Waiting Queue Overflow
		m_htiWQOF = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_WAITINGQUEUE_OVERFLOW), m_ProReleasersTweaks , m_iWQOF);
		m_htiInfiniteQueue = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_INFINITEQUEUE), m_ProReleasersTweaks, m_iInfiniteQueue);	// SLUGFILLER: infiniteQueue

		m_htiEnableAntiLeecher = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_ANTI_LEECHER), m_SourceHandlingTweaks, m_bEnableAntiLeecher); //MORPH - Added by IceCream, Enable Anti-leecher
		m_htiEnableAntiCreditHack = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_ANTI_CREDITHACK), m_SourceHandlingTweaks, m_bEnableAntiCreditHack); //MORPH - Added by IceCream, Enable Anti-CreditHack
		//Sivka: AutoHL
		m_htiEnableAutoHL = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_AUTOHARDLIMIT), m_SourceHandlingTweaks , m_bEnableAutoHL);
		m_htiHardLimitTimer = m_ctrlTreeOptions.InsertItem(GetResString(IDS_AHL_TIMERLABEL), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_SourceHandlingTweaks);
		m_ctrlTreeOptions.AddEditBox(m_htiHardLimitTimer, RUNTIME_CLASS(CNumTreeOptionsEdit));
		m_htiEnableACC = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_ACTIVECONNCONTROL), m_SourceHandlingTweaks , m_bEnableACC); //Obelix
		//Sivka: AutoHL
		//Pawcio: HQRS
		m_htiDropHQRS = m_ctrlTreeOptions.InsertItem(GetResString(IDS_DROPHQRS), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_SourceHandlingTweaks);
		m_ctrlTreeOptions.AddEditBox(m_htiDropHQRS, RUNTIME_CLASS(CNumTreeOptionsEdit));
		//Pawcio: Moonlight SUQWT
		m_htiEnableMSUQWT = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_MSUQWT), m_SourceHandlingTweaks, m_bEnableMSUQWT);
		//Pawcio: Credits
		m_htiPawcioCredits = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_PCREDITS), m_AdditionalTweaks , m_iPawcioCredits);
		BOOL bCheck;
		if (m_ctrlTreeOptions.GetCheckBox(m_htiCreditSystem, bCheck))
			m_ctrlTreeOptions.SetCheckBoxEnable(m_htiPawcioCredits, bCheck);
		//Pawcio: Credits
		//Pawcio: Red Files
		m_htiRedFiles = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_REDFILES), m_AdditionalTweaks , m_iRedFiles);
		//MORPH START - Added by IceCream, high process priority
		m_htiHighProcess = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_HIGHPROCESS), m_AdditionalTweaks, m_iHighProcess);
		//MORPH END   - Added by IceCream, high process priority
		m_htiEDT = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_EDT), m_AdditionalTweaks, m_bEDT); //enkeyDev -EDT-

		m_htiFilterLANIPs = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_PW_FILTER), TVI_ROOT, m_iFilterLANIPs);
		m_htiExtControls = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_SHOWEXTSETTINGS), TVI_ROOT, m_iExtControls);
		m_htiServerKeepAliveTimeout = m_ctrlTreeOptions.InsertItem(GetResString(IDS_SERVERKEEPALIVETIMEOUT), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, TVI_ROOT);
		m_ctrlTreeOptions.AddEditBox(m_htiServerKeepAliveTimeout, RUNTIME_CLASS(CNumTreeOptionsEdit));

		m_htiSaveLogs = m_ctrlTreeOptions.InsertGroup(GetResString(IDS_LOG2DISKFRAME), iImgLog, TVI_ROOT);
		m_htiLog2Disk = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_LOG2DISK), m_htiSaveLogs, m_iLog2Disk);
		m_htiDebug2Disk = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_DEBUG2DISK), m_htiSaveLogs, m_iDebug2Disk);

		m_htiCommit = m_ctrlTreeOptions.InsertGroup(GetResString(IDS_COMMITFILES), iImgBackup, TVI_ROOT);
		m_htiCommitNever = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_NEVER), m_htiCommit, m_iCommitFiles == 0);
		m_htiCommitOnShutdown = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_ONSHUTDOWN), m_htiCommit, m_iCommitFiles == 1);
		m_htiCommitAlways = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_ALWAYS), m_htiCommit, m_iCommitFiles == 2);

		m_htiCheckDiskspace = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_CHECKDISKSPACE), TVI_ROOT, m_iCheckDiskspace);	// SLUGFILLER: checkDiskspace
		m_htiMinFreeDiskSpace = m_ctrlTreeOptions.InsertItem(GetResString(IDS_MINFREEDISKSPACE), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_htiCheckDiskspace);
		m_ctrlTreeOptions.AddEditBox(m_htiMinFreeDiskSpace, RUNTIME_CLASS(CNumTreeOptionsEdit));
		// itsonlyme: hostnameSource
		m_htiYourHostname = m_ctrlTreeOptions.InsertItem(GetResString(IDS_YOURHOSTNAME), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, TVI_ROOT);
		m_ctrlTreeOptions.AddEditBox(m_htiYourHostname, RUNTIME_CLASS(CTreeOptionsEdit));
		// itsonlyme: hostnameSource

		m_ctrlTreeOptions.Expand(m_htiSaveLogs, TVE_EXPAND);
		m_ctrlTreeOptions.Expand(m_htiCommit, TVE_EXPAND);
		m_ctrlTreeOptions.Expand(m_htiCheckDiskspace, TVE_EXPAND);
		//m_ctrlTreeOptions.Expand(otiAV, TVE_EXPAND);// The Black Hand: Antivirus check - Pawcio
		//m_ctrlTreeOptions.Expand(m_ProReleasersTweaks, TVE_EXPAND); //Pawcio: Pro-Releaser
		//m_ctrlTreeOptions.Expand(m_SourceHandlingTweaks, TVE_EXPAND);//Pawcio: Source Handling
		m_ctrlTreeOptions.Expand(m_AdditionalTweaks, TVE_EXPAND);// Pawcio: Additional Tweaks
		m_ctrlTreeOptions.SendMessage(WM_VSCROLL, SB_TOP);
		m_bInitializedTreeOpts = true;
	}

	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiMaxCon5Sec, m_iMaxConnPerFive);
	DDV_MinMaxInt(pDX, m_iMaxConnPerFive, 1, INT_MAX);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiAutoTakeEd2kLinks, m_iAutoTakeEd2kLinks);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiVerbose, m_iVerbose);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiDebugSourceExchange, m_iDebugSourceExchange);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiCreditSystem, m_iCreditSystem);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiLog2Disk, m_iLog2Disk);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiDebug2Disk, m_iDebug2Disk);
	DDX_TreeRadio(pDX, IDC_EXT_OPTS, m_htiCommit, m_iCommitFiles);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiFilterLANIPs, m_iFilterLANIPs);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiExtControls, m_iExtControls);
	DDX_Text(pDX, IDC_EXT_OPTS, m_htiServerKeepAliveTimeout, m_uServerKeepAliveTimeout);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiPawcioCredits, m_iPawcioCredits); //Pawcio: Credits
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiRedFiles, m_iRedFiles);//Pawcio: Red Files
	//Sivka: AutoHL
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiEnableAutoHL, m_bEnableAutoHL);
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiHardLimitTimer, m_iHardLimitTimer);
	DDV_MinMaxInt(pDX, m_iHardLimitTimer, 0, 60);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiEnableACC, m_bEnableACC); //Obelix
	//Sivka: AutoHL
	//Pawcio: Limits for PS
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiPSforPF, m_iPSforPF);
	DDV_MinMaxInt(pDX, m_iPSforPF, 1, 20);
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiPSforCF, m_iPSforCF);
	DDV_MinMaxInt(pDX, m_iPSforCF, 1, 50);
	//Pawcio: Moonlight SUQWT
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiEnableMSUQWT, m_bEnableMSUQWT);
	//Xman: Waiting Queue Overflow
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiWQOF, m_iWQOF);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiEnableAntiLeecher, m_bEnableAntiLeecher); //MORPH - Added by IceCream, enable Anti-leecher
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiEnableAntiCreditHack, m_bEnableAntiCreditHack); //MORPH - Added by IceCream, enable Anti-CreditHack
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiIsAutoPowershareNewDownloadFile, m_bIsAutoPowershareNewDownloadFile);//MORPH - Added by SiRoB, Avoid misusing of powersharing
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiCheckDiskspace, m_iCheckDiskspace);	// SLUGFILLER: checkDiskspace
	DDX_Text(pDX, IDC_EXT_OPTS, m_htiMinFreeDiskSpace, m_fMinFreeDiskSpaceMB);
	DDV_MinMaxFloat(pDX, m_fMinFreeDiskSpaceMB, 0.0, UINT_MAX / (1024*1024));
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiYourHostname, m_sYourHostname);	// itsonlyme: hostnameSource

	// The Black Hand: Antivirus Check - Pawcio
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, otiAVFileCheck, m_iAV);
	DDX_TreeFileEdit(pDX, IDC_EXT_OPTS, otiFile, m_sAVFile);
	DDV_MaxChars(pDX,m_sAVFile, 500);
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, otiAVParameter, m_sAVParameters);
	// The Black Hand: Antivirus Check - Pawcio
	// SLUGFILLER: hideOS
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiHideOS, m_iHideOS);
	DDV_MinMaxInt(pDX, m_iHideOS, 0, INT_MAX);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiSelectiveShare, m_iSelectiveShare);
	// SLUGFILLER: hideOS
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiInfiniteQueue, m_iInfiniteQueue);	// SLUGFILLER: infiniteQueue
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiHighProcess, m_iHighProcess); //MORPH - Added by IceCream, high process priority 
	// Pawcio: HQRS
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiDropHQRS, m_iDropHQRS);
	DDV_MinMaxInt(pDX, m_iDropHQRS, 0, INT_MAX);
	// Pawcio: HQRS
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiEDT, m_bEDT); //enkeyDev -EDT-
	m_ctrlTreeOptions.SetCheckBoxEnable(m_htiDebugSourceExchange, m_iVerbose);
}

BOOL CPPgTweaks::OnInitDialog()
{
	m_iMaxConnPerFive = app_prefs->GetMaxConperFive();
	m_iAutoTakeEd2kLinks = app_prefs->prefs->autotakeed2klinks;
	m_iVerbose = app_prefs->prefs->m_bVerbose;
	m_iDebugSourceExchange = app_prefs->prefs->m_bDebugSourceExchange;
	m_iLog2Disk = app_prefs->prefs->log2disk;
	m_iDebug2Disk = app_prefs->prefs->debug2disk;
	m_iCreditSystem = app_prefs->prefs->m_bCreditSystem;
	m_iCommitFiles = app_prefs->prefs->m_iCommitFiles;
	m_iFilterLANIPs = app_prefs->prefs->filterBadIP;
	m_iExtControls = app_prefs->prefs->m_bExtControls;
	m_uServerKeepAliveTimeout = app_prefs->prefs->m_dwServerKeepAliveTimeout / 60000;
	m_iPawcioCredits = app_prefs->prefs->PCredits; //Pawcio: Credits
	m_iRedFiles = app_prefs->prefs->redFiles;//Pawcio: Red Files
	//Sivka: AutoHL
	m_bEnableAutoHL = app_prefs->prefs->m_EnableAutoHLDefault;
	m_iHardLimitTimer = app_prefs->prefs->m_AutoHL_TimerDefault/1000;
	m_bEnableACC = app_prefs->prefs->m_activeConnectionControl; //Obelix
	//Sivka: AutoHL
	//Pawcio: Limits for PS
	m_iPSforPF = app_prefs->prefs->PSforPF;
	m_iPSforCF = app_prefs->prefs->PSforCF;
	//Pawcio: Moonlight SUQWT
	m_bEnableMSUQWT = app_prefs->prefs->enableMSUQWT;
	//Xman: Waiting Queue Overflow
	m_iWQOF = app_prefs->prefs->m_bWQueueOverflow;
	m_bEnableAntiLeecher = app_prefs->prefs->enableAntiLeecher; //MORPH - Added by IceCream, enabnle Anti-leecher
	m_bEnableAntiCreditHack = app_prefs->prefs->enableAntiCreditHack; //MORPH - Added by IceCream, enabnle Anti-CreditHack
	m_bIsAutoPowershareNewDownloadFile = app_prefs->prefs->m_bisautopowersharenewdownloadfile;//MORPH - Added by SiRoB, Avoid misusing of powersharing
	m_iCheckDiskspace = app_prefs->prefs->checkDiskspace;	// SLUGFILLER: checkDiskspace
	m_fMinFreeDiskSpaceMB = (float)(app_prefs->prefs->m_uMinFreeDiskSpace / (1024.0 * 1024.0));
	m_sYourHostname = app_prefs->GetYourHostname();	// itsonlyme: hostnameSource
	// The Black Hand: Antivirus check - Pawcio
	m_sAVParameters = app_prefs->prefs->m_aVParameter;
	m_sAVFile = app_prefs->prefs->m_aVFilename;
	m_iAV = app_prefs->prefs->m_aVCheck;;
	// The Black Hand: Antivirus check - Pawcio
	// SLUGFILLER: hideOS
	m_iHideOS = app_prefs->prefs->hideOS;
	m_iSelectiveShare = app_prefs->prefs->selectiveShare;
	// SLUGFILLER: hideOS
	// Pawcio: HQRS
	m_iInfiniteQueue = app_prefs->prefs->infiniteQueue;	// SLUGFILLER: infiniteQueue
	m_iDropHQRS = app_prefs->prefs->highQueueRate;
	//MORPH START - Added by IceCream, high process priority
	m_iHighProcess = app_prefs->GetEnableHighProcess();
	//MORPH END   - Added by IceCream, high process priority
	m_bEDT = app_prefs->prefs->sendEDT; //enkeyDev -EDT-
	CPropertyPage::OnInitDialog();
	InitWindowStyles(this);

	((CSliderCtrl*)GetDlgItem(IDC_FILEBUFFERSIZE))->SetRange(1,100,true);
	((CSliderCtrl*)GetDlgItem(IDC_FILEBUFFERSIZE))->SetPos(app_prefs->prefs->m_iFileBufferSize);
	m_iFileBufferSize = app_prefs->prefs->m_iFileBufferSize;

	((CSliderCtrl*)GetDlgItem(IDC_QUEUESIZE))->SetRange(20,100,true);
	((CSliderCtrl*)GetDlgItem(IDC_QUEUESIZE))->SetPos(app_prefs->prefs->m_iQueueSize);
	m_iQueueSize = app_prefs->prefs->m_iQueueSize;

	if (m_htiPawcioCredits) m_ctrlTreeOptions.SetCheckBoxEnable(m_htiPawcioCredits, m_iCreditSystem);//Pawcio: Credits

	Localize();

	return TRUE;  // return TRUE unless you set the focus to a control
				  // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CPPgTweaks::OnKillActive()
{
	// if prop page is closed by pressing VK_ENTER we have to explicitly commit any possibly pending
	// data from an open edit control
	m_ctrlTreeOptions.HandleChildControlLosingFocus();
	return CPropertyPage::OnKillActive();
}

BOOL CPPgTweaks::OnApply()
{
	// if prop page is closed by pressing VK_ENTER we have to explicitly commit any possibly pending
	// data from an open edit control
	m_ctrlTreeOptions.HandleChildControlLosingFocus();

	if (!UpdateData())
		return FALSE;

	app_prefs->SetMaxConsPerFive(m_iMaxConnPerFive ? m_iMaxConnPerFive : DFLT_MAXCONPERFIVE);
	theApp.scheduler->original_cons5s = app_prefs->GetMaxConperFive();

	if (app_prefs->prefs->autotakeed2klinks != m_iAutoTakeEd2kLinks){
		app_prefs->prefs->autotakeed2klinks = m_iAutoTakeEd2kLinks;
		RevertReg();
	}

	app_prefs->prefs->m_bVerbose = m_iVerbose;
	app_prefs->prefs->m_bDebugSourceExchange = m_iDebugSourceExchange;
	app_prefs->prefs->m_bCreditSystem = m_iCreditSystem;
	app_prefs->prefs->PCredits = m_iPawcioCredits; //Pawcio: Credits
	app_prefs->prefs->redFiles = m_iRedFiles;//Pawcio: Red Files
	//Sivka: AutoHL
	app_prefs->prefs->m_EnableAutoHLDefault = m_bEnableAutoHL;
	app_prefs->prefs->m_AutoHL_TimerDefault = m_iHardLimitTimer*1000;
	app_prefs->prefs->m_activeConnectionControl = m_bEnableACC; //Obelix
	//Sivka: AutoHL
	//Pawcio: Limits for PS
	app_prefs->prefs->PSforPF = m_iPSforPF;
	app_prefs->prefs->PSforCF = m_iPSforCF;
	//Pawcio: Moonlight SUQWT
	bool bRestartApp = false;
	if (app_prefs->prefs->enableMSUQWT != (bool)m_bEnableMSUQWT){
		bRestartApp = true;
		app_prefs->prefs->enableMSUQWT = m_bEnableMSUQWT;
	}
	//Xman: Waiting Queue Overflow
	app_prefs->prefs->m_bWQueueOverflow = m_iWQOF;
	app_prefs->prefs->log2disk = m_iLog2Disk;
	app_prefs->prefs->debug2disk = m_iDebug2Disk;
	app_prefs->prefs->m_iCommitFiles = m_iCommitFiles;
	app_prefs->prefs->filterBadIP = m_iFilterLANIPs;
	app_prefs->prefs->m_iFileBufferSize = m_iFileBufferSize;
	app_prefs->prefs->m_iQueueSize = m_iQueueSize;
	if (app_prefs->prefs->m_bExtControls != (bool)m_iExtControls) {
		app_prefs->prefs->m_bExtControls = m_iExtControls;
		theApp.emuledlg->transferwnd.downloadlistctrl.CreateMenues();
		theApp.emuledlg->searchwnd->searchlistctrl.CreateMenues();
		theApp.emuledlg->sharedfileswnd.sharedfilesctrl.CreateMenues();
	}
	app_prefs->prefs->m_dwServerKeepAliveTimeout = m_uServerKeepAliveTimeout * 60000;
	// SLUGFILLER: hideOS
	app_prefs->prefs->hideOS = m_iHideOS;
	app_prefs->prefs->selectiveShare = m_iSelectiveShare;
	// SLUGFILLER: hideOS
	app_prefs->prefs->infiniteQueue = m_iInfiniteQueue;	// SLUGFILLER: infiniteQueue
	app_prefs->prefs->checkDiskspace = m_iCheckDiskspace;	// SLUGFILLER: checkDiskspace
	app_prefs->prefs->m_uMinFreeDiskSpace = (UINT)(m_fMinFreeDiskSpaceMB * (1024 * 1024));
	app_prefs->SetYourHostname(m_sYourHostname);	// itsonlyme: hostnameSource
	app_prefs->prefs->enableAntiLeecher = m_bEnableAntiLeecher; //MORPH - Added by IceCream, enable Anti-leecher
	app_prefs->prefs->enableAntiCreditHack = m_bEnableAntiCreditHack; //MORPH - Added by IceCream, enable Anti-CreditHack
	app_prefs->prefs->m_bisautopowersharenewdownloadfile = m_bIsAutoPowershareNewDownloadFile;//MORPH - Added by SiRoB, Avoid misusing of powersharing
	// The Black Hand: Antivirus check - Pawcio
	strncpy(app_prefs->prefs->m_aVParameter, m_sAVParameters.GetBuffer(),250);
	app_prefs->prefs->m_aVParameter[250]=0;
	strncpy(app_prefs->prefs->m_aVFilename, m_sAVFile.GetBuffer(),500);
	app_prefs->prefs->m_aVFilename[500]=0;
	app_prefs->prefs->m_aVCheck = m_iAV;
	// The Black Hand: Antivirus check - Pawcio
	theApp.emuledlg->serverwnd.ToggleDebugWindow();
	theApp.emuledlg->serverwnd.UpdateLogTabSelection();
	theApp.downloadqueue->CheckDiskspace();
	// Pawcio: HQRS
	if (m_iDropHQRS != 0 && m_iDropHQRS < 99)
		m_iDropHQRS = 100;
	app_prefs->prefs->highQueueRate = m_iDropHQRS;
	// Pawcio: HQRS
	//MORPH START - Added by IceCream, high process priority
	app_prefs->SetEnableHighProcess(m_iHighProcess);
	//MORPH END   - Added by IceCream, high process priority
	app_prefs->prefs->sendEDT = m_bEDT; //enkeyDev -EDT-
	SetModified(FALSE);

	//Pawcio: Moonlight SUQWT
	if (bRestartApp){
		if (!app_prefs->prefs->enableMSUQWT){
			CString strBakFileName;
			strBakFileName.Format(_T("%s") CLIENTS_MET_FILENAME _T(".BAK"), app_prefs->GetConfigDir());
			CFile fileToDel(strBakFileName,CFile::modeCreate);
			fileToDel.Close();
		}
		AfxMessageBox(GetResString(IDS_SETTINGCHANGED_RESTART));
	}

	return CPropertyPage::OnApply();
}

void CPPgTweaks::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SetModified(TRUE);
	
	CSliderCtrl* slider =(CSliderCtrl*)pScrollBar;
	CString temp;
	if (pScrollBar==GetDlgItem(IDC_FILEBUFFERSIZE)) {
		m_iFileBufferSize = slider->GetPos();
		temp.Format( GetResString(IDS_FILEBUFFERSIZE), m_iFileBufferSize*30000 );
		GetDlgItem(IDC_FILEBUFFERSIZE_STATIC)->SetWindowText(temp);
	}
	else if (pScrollBar==GetDlgItem(IDC_QUEUESIZE)) {
		m_iQueueSize = slider->GetPos();
		temp.Format( GetResString(IDS_QUEUESIZE), m_iQueueSize*100);
		GetDlgItem(IDC_QUEUESIZE_STATIC)->SetWindowText(temp);
	}
}

void CPPgTweaks::Localize(void)
{	
	if(m_hWnd)
	{
		SetWindowText(GetResString(IDS_PW_TWEAK));
		GetDlgItem(IDC_WARNING)->SetWindowText(GetResString(IDS_TWEAKS_WARNING));

		if (m_htiMaxCon5Sec) m_ctrlTreeOptions.SetEditLabel(m_htiMaxCon5Sec, GetResString(IDS_MAXCON5SECLABEL));
		if (m_htiAutoTakeEd2kLinks) m_ctrlTreeOptions.SetItemText(m_htiAutoTakeEd2kLinks, GetResString(IDS_AUTOTAKEED2KLINKS));
		if (m_htiVerbose) m_ctrlTreeOptions.SetItemText(m_htiVerbose, GetResString(IDS_VERBOSE));
		if (m_htiDebugSourceExchange) m_ctrlTreeOptions.SetItemText(m_htiDebugSourceExchange, GetResString(IDS_DEBUG_SOURCE_EXCHANGE));
		if (m_htiCreditSystem) m_ctrlTreeOptions.SetItemText(m_htiCreditSystem, GetResString(IDS_USECREDITSYSTEM));
		if (m_htiEnableAntiLeecher) m_ctrlTreeOptions.SetItemText(m_htiEnableAntiLeecher, GetResString(IDS_ANTI_LEECHER)); //MORPH - Added by IceCream, enable Anti-leecher
		if (m_htiEnableAntiCreditHack) m_ctrlTreeOptions.SetItemText(m_htiEnableAntiCreditHack, GetResString(IDS_ANTI_CREDITHACK)); //MORPH - Added by IceCream, enable Anti-CreditHack

		//MORPH START - Added by IceCream, high process priority
		if (m_htiHighProcess) m_ctrlTreeOptions.SetItemText(m_htiHighProcess, GetResString(IDS_HIGHPROCESS));
		//MORPH END   - Added by IceCream, high process priority
		if (m_htiSaveLogs) m_ctrlTreeOptions.SetItemText(m_htiSaveLogs, GetResString(IDS_LOG2DISKFRAME));
		if (m_htiLog2Disk) m_ctrlTreeOptions.SetItemText(m_htiLog2Disk, GetResString(IDS_LOG2DISK));
		if (m_htiDebug2Disk) m_ctrlTreeOptions.SetItemText(m_htiDebug2Disk, GetResString(IDS_DEBUG2DISK));

		if (m_htiCommit) m_ctrlTreeOptions.SetItemText(m_htiCommit, GetResString(IDS_COMMITFILES));
		if (m_htiCommitNever) m_ctrlTreeOptions.SetItemText(m_htiCommitNever, GetResString(IDS_NEVER));
		if (m_htiCommitOnShutdown) m_ctrlTreeOptions.SetItemText(m_htiCommitOnShutdown, GetResString(IDS_ONSHUTDOWN));
		if (m_htiCommitAlways) m_ctrlTreeOptions.SetItemText(m_htiCommitAlways, GetResString(IDS_ALWAYS));
		if (m_htiFilterLANIPs) m_ctrlTreeOptions.SetItemText(m_htiFilterLANIPs, GetResString(IDS_PW_FILTER));
		if (m_htiExtControls) m_ctrlTreeOptions.SetItemText(m_htiExtControls, GetResString(IDS_SHOWEXTSETTINGS));
		if (m_htiServerKeepAliveTimeout) m_ctrlTreeOptions.SetEditLabel(m_htiServerKeepAliveTimeout, GetResString(IDS_SERVERKEEPALIVETIMEOUT));
		// SLUGFILLER: hideOS
		if (m_htiHideOS) m_ctrlTreeOptions.SetEditLabel(m_htiHideOS, GetResString(IDS_HIDEOVERSHARES));
		if (m_htiSelectiveShare) m_ctrlTreeOptions.SetItemText(m_htiSelectiveShare, GetResString(IDS_SELECTIVESHARE));
		// SLUGFILLER: hideOS
		if (m_htiInfiniteQueue) m_ctrlTreeOptions.SetItemText(m_htiInfiniteQueue, GetResString(IDS_INFINITEQUEUE));	// SLUGFILLER: infiniteQueue
		if (m_htiCheckDiskspace) m_ctrlTreeOptions.SetItemText(m_htiCheckDiskspace, GetResString(IDS_CHECKDISKSPACE));	// SLUGFILLER: checkDiskspace
		if (m_htiMinFreeDiskSpace) m_ctrlTreeOptions.SetEditLabel(m_htiMinFreeDiskSpace, GetResString(IDS_MINFREEDISKSPACE));
		if (m_htiYourHostname) m_ctrlTreeOptions.SetEditLabel(m_htiYourHostname, GetResString(IDS_YOURHOSTNAME));	// itsonlyme: hostnameSource
		if (m_htiPawcioCredits) m_ctrlTreeOptions.SetItemText(m_htiPawcioCredits, GetResString(IDS_PCREDITS));//Pawcio: Credits
		if (m_htiRedFiles) m_ctrlTreeOptions.SetItemText(m_htiRedFiles, GetResString(IDS_REDFILES));//Pawcio: Red Files
		//Sivka: AutoHL
		if (m_htiEnableAutoHL) m_ctrlTreeOptions.SetItemText(m_htiEnableAutoHL, GetResString(IDS_AUTOHARDLIMIT));
		if (m_htiHardLimitTimer) m_ctrlTreeOptions.SetEditLabel(m_htiHardLimitTimer, GetResString(IDS_AHL_TIMERLABEL));
		if (m_htiEnableACC) m_ctrlTreeOptions.SetItemText(m_htiEnableACC, GetResString(IDS_ACTIVECONNCONTROL)); //Obelix
		//Sivka: AutoHL
		//Pawcio: Limits for PS
		if (m_htiPSforPF) m_ctrlTreeOptions.SetEditLabel(m_htiPSforPF, GetResString(IDS_PSFORPF));
		if (m_htiPSforCF) m_ctrlTreeOptions.SetEditLabel(m_htiPSforCF, GetResString(IDS_PSFORCF));
		//Pawcio: Moonlight SUQWT
		if (m_htiEnableMSUQWT) m_ctrlTreeOptions.SetItemText(m_htiEnableMSUQWT, GetResString(IDS_MSUQWT));
		//Xman: Waiting Queue Overflow
		if (m_htiWQOF) m_ctrlTreeOptions.SetItemText(m_htiWQOF, GetResString(IDS_WAITINGQUEUE_OVERFLOW));
		// The Black Hand: Antivirus Check - Pawcio
		if (otiAVFileCheck) m_ctrlTreeOptions.SetItemText(otiAVFileCheck, GetResString(IDS_AVCHECK));
		if (otiFile) m_ctrlTreeOptions.SetEditLabel(otiFile, GetResString(IDS_AVFILE));
		if (otiAVParameter) m_ctrlTreeOptions.SetEditLabel(otiAVParameter, GetResString(IDS_AVPARAMETER));
		// The Black Hand: Antivirus check - Pawcio
		// Pawcio: HQRS
		if (m_htiDropHQRS) m_ctrlTreeOptions.SetEditLabel(m_htiDropHQRS, GetResString(IDS_DROPHQRS));
		if (m_ProReleasersTweaks)  m_ctrlTreeOptions.SetItemText(m_ProReleasersTweaks, GetResString(IDS_PRORELEASERS)); //Pawcio: Pro-Releaser
		if (m_SourceHandlingTweaks) m_ctrlTreeOptions.SetItemText(m_SourceHandlingTweaks, GetResString(IDS_SOURCEHANDLING)); //Pawcio: Source Handling
		if (m_htiEDT) m_ctrlTreeOptions.SetItemText(m_htiEDT, GetResString(IDS_EDT)); //enkeyDev -EDT-
		CString temp;
		temp.Format( GetResString(IDS_FILEBUFFERSIZE), m_iFileBufferSize*30000 );
		GetDlgItem(IDC_FILEBUFFERSIZE_STATIC)->SetWindowText(temp);
		temp.Format( GetResString(IDS_QUEUESIZE), m_iQueueSize*100 );
		GetDlgItem(IDC_QUEUESIZE_STATIC)->SetWindowText(temp);
	}
}

void CPPgTweaks::OnDestroy()
{
	m_ctrlTreeOptions.DeleteAllItems();
	m_ctrlTreeOptions.DestroyWindow();
	m_bInitializedTreeOpts = false;
	m_htiMaxCon5Sec = NULL;
	m_htiAutoTakeEd2kLinks = NULL;
	m_htiVerbose = NULL;
	m_htiDebugSourceExchange = NULL;
	m_htiCreditSystem = NULL;
	m_htiSaveLogs = NULL;
	m_htiLog2Disk = NULL;
	m_htiDebug2Disk = NULL;
	m_htiCommit = NULL;
	m_htiCommitNever = NULL;
	m_htiCommitOnShutdown = NULL;
	m_htiCommitAlways = NULL;
	m_htiFilterLANIPs = NULL;
	m_htiExtControls = NULL;
	m_htiServerKeepAliveTimeout = NULL;
	m_AdditionalTweaks = NULL;
	m_ProReleasersTweaks = NULL; //Pawcio: Pro-Releaser
	m_SourceHandlingTweaks = NULL; //Pawcio: Source Handling
	// SLUGFILLER: hideOS
	m_htiHideOS = NULL;
	m_htiSelectiveShare = NULL;
	// SLUGFILLER: hideOS
	m_htiInfiniteQueue = NULL;	// SLUGFILLER: infiniteQueue
	m_htiCheckDiskspace = NULL;	// SLUGFILLER: checkDiskspace
	m_htiMinFreeDiskSpace = NULL;
	m_htiYourHostname = NULL;	// itsonlyme: hostnameSource
	m_htiPawcioCredits = NULL; //Pawcio: Credits
	m_htiRedFiles = NULL;//Pawcio: Red Files
	//Sivka: AutoHL
	m_htiEnableAutoHL = NULL;
	m_htiHardLimitTimer = NULL;
	m_htiEnableACC = NULL; //Obelix
	//Sivka: AutoHL
	//Pawcio: Limits for PS
	m_htiPSforPF = NULL;
	m_htiPSforCF = NULL;
	//Pawcio: Moonlight SUQWT
	m_htiEnableMSUQWT = NULL;
	//Xman: Waiting Queue Overflow
	m_htiWQOF = NULL;
	m_htiEnableAntiLeecher = NULL; //MORPH - Added by IceCream, enable Anti-leecher
	m_htiEnableAntiCreditHack = NULL; //MORPH - Added by IceCream, enable Anti-CreditHack
	// The Black Hand: Antivirus Check - Pawcio
	otiAV = NULL;
	otiAVFileCheck = NULL;
	otiAVParameter = NULL;
	otiFile = NULL;
	// The Black Hand: Antivirus Check - Pawcio
	//Pawcio: HQRS
	m_htiDropHQRS = NULL;
	m_htiHighProcess = NULL; //MORPH - Added by IceCream, high process priority
	m_htiEDT = NULL; //enkeyDev -EDT-
	CPropertyPage::OnDestroy();
}

LRESULT CPPgTweaks::OnTreeOptsCtrlNotify(WPARAM wParam, LPARAM lParam)
{
	if (wParam == IDC_EXT_OPTS){
		TREEOPTSCTRLNOTIFY* pton = (TREEOPTSCTRLNOTIFY*)lParam;
		if (pton->hItem == m_htiVerbose){
			BOOL bCheck;
			if (m_ctrlTreeOptions.GetCheckBox(m_htiVerbose, bCheck))
				m_ctrlTreeOptions.SetCheckBoxEnable(m_htiDebugSourceExchange, bCheck);
		}
		//Pawcio: Credits
		else if (pton->hItem == m_htiCreditSystem){
			BOOL bCheck;
			if (m_ctrlTreeOptions.GetCheckBox(m_htiCreditSystem, bCheck))
				m_ctrlTreeOptions.SetCheckBoxEnable(m_htiPawcioCredits, bCheck);
		}
		//Pawcio: Credits
		SetModified();
	}
	return 0;
}
